## erlang-cl 1.2.1

=== examples/Makefile ===

MODULES = \
	cl_basic \
	cl_square_float \
	cl_map \
	cl_binary_test \
	cl_bandwidth \
	cl_test



EBIN = ../ebin
ERLC = erlc

override ERLC_FLAGS = -W -pa ../../cl/ebin

OBJS = $(MODULES:%=$(EBIN)/%.beam)

TARGET_FILES = $(OBJS)

debug: ERLC_FLAGS += -Ddebug 

all: $(TARGET_FILES)

debug: all

release: all

depend:
	edep -MM -o ../ebin $(ERLC_FLAGS) $(MODULES:%=%.erl) > depend.mk

dialyze:
	dialyzer --src -o dia.out $(ERLC_FLAGS) -c $(MODULES:%=%.erl) 

clean:
	rm -f $(OBJS)

-include depend.mk

$(EBIN)/%.beam:	%.erl
	$(ERLC) $(ERLC_FLAGS) -o $(EBIN) $<

=== debian/changelog ===
erlang-cl (1.2.1-1) unstable; urgency=low

  * Initial release (closes: #726635).

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 17 Oct 2013 22:44:17 +0400

=== debian/control ===
Source: erlang-cl
Maintainer: Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>
Uploaders: Sergei Golovan <sgolovan@debian.org>
Section: libs
Priority: optional
Standards-Version: 3.9.4
Homepage: https://github.com/tonyrog/cl
Build-Depends: debhelper (>= 9.0.0), erlang-dev, erlang-edoc, dh-rebar, ocl-icd-opencl-dev

Package: erlang-cl
Architecture: any
Section: libs
Priority: optional
Depends: ${erlang:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Erlang OpenCL bindings
 CL is an application which provides OpenCL bindings to Erlang.
 It resembles C API from http://www.khronos.org/opencl as close
 as possible.

=== debian/rules ===
#! /usr/bin/make -f

%:
	dh $@ --buildsystem=rebar --with rebar

override_dh_clean:
	dh_clean doc/*.html doc/*.css doc/erlang.png doc/edoc-info

override_dh_gencontrol:
	erlang-depends
	dh_gencontrol

override_dh_compress:
	dh_compress -X.erl -X.cl
	# remove useless files and fix html dir
	rm -f debian/erlang-cl/usr/share/doc/erlang-cl/doc/*.edoc
	rm -f debian/erlang-cl/usr/share/doc/erlang-cl/doc/.gitignore
	mv debian/erlang-cl/usr/share/doc/erlang-cl/doc \
	   debian/erlang-cl/usr/share/doc/erlang-cl/html

get-orig-source:
	wget -O erlang-cl_1.2.1.orig.tar.gz https://github.com/tonyrog/cl/archive/cl-1.2.1.tar.gz

.PHONY: override_dh_clean override_dh_gencontrol override_dh_compress get-orig-source

## erlang-cl 1.2.3

=== c_src/Makefile ===
#
# Copyright (C) 2016, Rogvall Invest AB, <tony@rogvall.se>
#
# This software is licensed as described in the file COPYRIGHT, which
# you should have received as part of this distribution. The terms
# are also available at http://www.rogvall.se/docs/copyright.txt.
#
# You may opt to use, copy, modify, merge, publish, distribute and/or sell
# copies of the Software, and permit persons to whom the Software is
# furnished to do so, under the terms of the COPYRIGHT file.
#
# This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
# KIND, either express or implied.
#

OSNAME := $(shell uname -s)
MACHINE := $(shell uname -m)
OUT_C = -o
OUT_L = -o
OBJ = o

## us NOCL=true make to force build with gcc on windows

WORDSIZE = $(shell erl -noshell -eval "io:format([126,119,126,110],[erlang:system_info(wordsize)*8])" -s erlang halt)

ifeq ($(ERLANG_ROOT_DIR), )
  ERLDIR := $(shell erl -noshell -eval "io:format([126,115,126,110],[code:root_dir()])" -s erlang halt)
  ERL_C_INCLUDE_DIR := "$(ERLDIR)/usr/include"
else
  ERL_C_INCLUDE_DIR := "$(ERLANG_ROOT_DIR)/usr/include"
endif

OCL_DIR := $(shell cd ..; pwd)

ifneq (, $(findstring MINGW,$(OSNAME)))
MINGW = Yes
endif

MAC_OS_X  = No
WIN32_GCC = No
WIN32_CL  = No
LINUX     = No

EXT       = so
PRIVDIR=../priv

ifeq ($(TYPE), debug)
CFLAGS += -Ddebug -DDEBUG -g -Wall -Wextra -Wswitch-default -Wswitch-enum -D_THREAD_SAFE
CFLAGS += -D_REENTRANT -fno-common -I$(ERL_C_INCLUDE_DIR)
WIN_DEBUG = -Ddebug -DDEBUG
endif

ifeq ($(TYPE), release)
CFLAGS += -Wall -Wextra -Wswitch-default -Wswitch-enum -D_THREAD_SAFE -D_REENTRANT -fno-common
CFLAGS += -Wno-deprecated-declarations -Wno-missing-field-initializers -I$(ERL_C_INCLUDE_DIR)
endif

ifeq ($(OSNAME), Linux)
LINUX = Yes
CFLAGS += -I/usr/include/nvidia-current
CFLAGS += -I/opt/AMDAPP/include
ifeq ($(WORDSIZE), 32)
CFLAGS += -O3 -fPIC -m32
endif
ifeq ($(WORDSIZE), 64)
CFLAGS += -O3 -fPIC -m64
endif
LD_SHARED	:= $(CC) -shared
LDFLAGS	        += -lOpenCL
endif

ifeq ($(OSNAME), Darwin)
MAC_OS_X = Yes
ifeq ($(WORDSIZE), 32)
CFLAGS += -O3 -fPIC -m32 -DDARWIN -no-cpp-precomp
LD_SHARED	:= $(CC) -m32 -bundle -flat_namespace -undefined suppress
endif
ifeq ($(WORDSIZE), 64)
CFLAGS += -O3 -fPIC -m64 -DDARWIN -no-cpp-precomp
LD_SHARED	:= $(CC) -m64 -bundle -flat_namespace -undefined suppress
endif
LDFLAGS += -framework OpenCL
endif

############### WINDOWS HACK
ifeq ($(MINGW), Yes)
EXT = dll
CC_OR_NOCL=$(findstring which:,$(shell which cl.exe))$(NOCL)
ifeq (, $(CC_OR_NOCL))
## Use Microsoft CL
	WIN32_CL = Yes
	CC=cl.exe
	MS2C = MSYS2_ARG_CONV_EXCL=*
	OUT_C = /Fo
	ifeq ($(OPENCL_DIR), )
	   OPENCL_DIR = c:/msys64/opt/local/
	endif
	CFLAGS = /FS /Zi /nologo /W1 -DWIN32 -D__WIN32__
	CFLAGS += /I$(OPENCL_DIR)/include /I$(ERL_C_INCLUDE_DIR)
	LD_SHARED=link.exe /DLL
	OUT_L=/OUT:
	ifeq ($(WORDSIZE), 32)
	   LDFLAGS += /NOLOGO $(OPENCL_DIR)/lib/x86/OpenCL.lib
	else
	   CFLAGS  += -DWIN_X64
	   LDFLAGS += /NOLOGO $(OPENCL_DIR)/lib/x64/OpenCL.lib
	endif
else
############## Use mingw-gcc
	CC=gcc
	WIN32_GCC = Yes
	CFLAGS += -D__WIN32__
	ifeq ($(OPENCL_DIR), )
	   OPENCL_DIR = /opt/local/
	endif

	ifeq ($(WORDSIZE), 32)
	   CFLAGS += -shared -I$(OPENCL_DIR)/include -m32 -DWIN32
	   LDFLAGS += -L$(OPENCL_DIR)/lib/x86 -lOpenCL
	endif
	ifeq ($(WORDSIZE), 64)
	   CFLAGS += -shared -I$(OPENCL_DIR)/include -m64 -DWIN32
	   LDFLAGS += -L$(OPENCL_DIR)/lib/x64 -lOpenCL
	endif

	LD_SHARED	:= $(CC) -shared
## Optimizations is broken on mingw 4.4.0 (it crashes with it on)
	GCC_VERSION = $(shell gcc -dumpversion)
	ifneq ($(GCC_VERSION), 4.4.0)
	    CFLAGS += -O3
	endif
endif
endif
############### WINDOWS end

CL_NIF = $(PRIVDIR)/cl_nif.$(EXT)

CL_NIF_OBJS = \
	cl_nif.$(OBJ) \
	cl_hash.$(OBJ)

CL_NIF_SRC = \
	cl_nif.c \
	cl_hash.c

all:
	$(MAKE) nif TYPE=release

debug:
	$(MAKE) nif TYPE=debug

clean:
	rm -f $(CL_NIF_OBJS)
	rm -f $(CL_NIF)

release:
	$(MAKE) nif TYPE=release

nif: $(CL_NIF)

cl_nif.$(OBJ): cl_hash.h

clean_internal:
	-rm -f *.$(OBJ)
	-rm -f $(PRIVDIR)/*.$(EXT)

ifeq ($(WIN32_CL),No)

%.$(OBJ): %.c
	$(CC) -c $(OUT_C) $@ $(CFLAGS) $<

$(CL_NIF): $(OCL_LIB) $(CL_NIF_OBJS)
	@mkdir -p $(PRIVDIR)
	$(LD_SHARED) $(OUT_L) $@ $(CL_NIF_OBJS) $(LDFLAGS)
else

%.$(OBJ): %.c
	$(MS2C) $(CC) -c $(OUT_C)$@ $(CFLAGS) $<

$(CL_NIF): $(OCL_LIB) $(CL_NIF_OBJS)
	@mkdir -p $(PRIVDIR)
	$(MS2C) $(LD_SHARED) $(OUT_L)$@ $(CL_NIF_OBJS) $(LDFLAGS)

endif

=== debian/changelog ===
erlang-cl (1.2.3-3) unstable; urgency=medium

  * Finally fixed rebar.config for GNU/kFreeBSD.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 19 Jan 2017 09:53:25 +0300

erlang-cl (1.2.3-2) unstable; urgency=medium

  * Removed the -m32 and -m64 options from gcc calls to prevent FTBFS for
    Linux architectures other than i386 and amd64, added another fix
    for GNU/kFreeBSD.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 18 Jan 2017 15:29:49 +0300

erlang-cl (1.2.3-1) unstable; urgency=medium

  * New upstream release.
  * Removed patches which are no lnger applicable. Redo patch which fixes
    build for GNU/kFreeBSD and GNU/Hurd.
  * Bumped standards version to 3.9.8.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 17 Jan 2017 09:46:18 +0300

erlang-cl (1.2.1-4) unstable; urgency=medium

  * Fixed GNU/kFreeBSD and GNU/Hurd build options for ports.
  * Bumped standards version to 3.9.7.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 03 Apr 2016 10:24:45 +0300

erlang-cl (1.2.1-3) unstable; urgency=medium

  * Added info on erlang-cl Debian package VCS.
  * Bumped standards version to 3.9.6.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 30 Dec 2015 08:46:03 +0300

erlang-cl (1.2.1-2) unstable; urgency=low

  * Rebuild against the current ocl-icd-opencl-dev package to fix
    dependencies (closes: #748360).
  * Bumped standards version to 3.9.5.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 17 May 2014 07:49:36 +0400

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,11 @@
 Uploaders: Sergei Golovan <sgolovan@debian.org>
 Section: libs
 Priority: optional
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9.0.0), erlang-dev, erlang-edoc, dh-rebar, ocl-icd-opencl-dev
+Standards-Version: 3.9.8
 Homepage: https://github.com/tonyrog/cl
-Build-Depends: debhelper (>= 9.0.0), erlang-dev, erlang-edoc, dh-rebar, ocl-icd-opencl-dev
+Vcs-Svn: svn://anonscm.debian.org/pkg-erlang/erlang-cl/trunk/
+Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-erlang/erlang-cl/trunk/
 
 Package: erlang-cl
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,6 @@
 	   debian/erlang-cl/usr/share/doc/erlang-cl/html
 
 get-orig-source:
-	wget -O erlang-cl_1.2.1.orig.tar.gz https://github.com/tonyrog/cl/archive/cl-1.2.1.tar.gz
+	wget -O erlang-cl_1.2.3.orig.tar.gz https://github.com/tonyrog/cl/archive/cl-1.2.3.tar.gz
 
 .PHONY: override_dh_clean override_dh_gencontrol override_dh_compress get-orig-source

## erlang-cl 1.2.4

=== debian/changelog ===
erlang-cl (1.2.4-2) unstable; urgency=medium

  * Fix the debian/watch uscan control file.
  * Bump the erlang build dependency to 1:27.
  * Bump the debhelper compatibility level to 13.
  * Bump standards version to 4.7.0.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 19 Feb 2025 19:56:33 +0300

erlang-cl (1.2.4-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Bump standards version to 4.2.0.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 01 Oct 2018 13:32:07 +0300

erlang-cl (1.2.3-4) unstable; urgency=medium

  * Add the debian/watch uscan file.
  * Replace the Alioth VCS headers by the new Salsa ones.
  * Bump the debhelper compatibility level to 10.
  * Bump standards version to 4.1.3.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 23 Mar 2018 12:44:26 +0300

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Uploaders: Sergei Golovan <sgolovan@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 9.0.0), erlang-dev, erlang-edoc, dh-rebar, ocl-icd-opencl-dev
-Standards-Version: 3.9.8
+Build-Depends: debhelper-compat (= 13), erlang-dev (>= 1:27), erlang-edoc, dh-rebar, ocl-icd-opencl-dev
+Standards-Version: 4.7.0
 Homepage: https://github.com/tonyrog/cl
-Vcs-Svn: svn://anonscm.debian.org/pkg-erlang/erlang-cl/trunk/
-Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-erlang/erlang-cl/trunk/
+Vcs-Browser: https://salsa.debian.org/erlang-team/packages/erlang-cl
+Vcs-Git: https://salsa.debian.org/erlang-team/packages/erlang-cl.git
 
 Package: erlang-cl
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #! /usr/bin/make -f
+
+v = 1.2.3
 
 %:
 	dh $@ --buildsystem=rebar --with rebar
@@ -19,6 +21,6 @@
 	   debian/erlang-cl/usr/share/doc/erlang-cl/html
 
 get-orig-source:
-	wget -O erlang-cl_1.2.3.orig.tar.gz https://github.com/tonyrog/cl/archive/cl-1.2.3.tar.gz
+	wget -O erlang-cl_$(v).orig.tar.gz https://github.com/tonyrog/cl/archive/cl-$(v).tar.gz
 
 .PHONY: override_dh_clean override_dh_gencontrol override_dh_compress get-orig-source

=== debian/watch ===
# Watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

https://github.com/tonyrog/cl/tags \
    /tonyrog/cl/archive/refs/tags/cl-([.\d]+).tar.gz
